//Incluir bibliotecas

#include "Nextion.h"
#define pot A0
void n0PopCallback(void *ptr);

NexDSButton bt0 = NexDSButton(0, 2, "bt0");    // Creamos el objeto bt0. Encender y apagar compresor
NexDSButton bt1 = NexDSButton(0, 5, "bt1");    // Creamos el objeto bt1. Encender y apagar pantalla
NexDSButton bt2 = NexDSButton(1, 12, "bt2");   // Creamos el objeto bt2. Meter presion balona izq
NexDSButton bt3 = NexDSButton(1, 3, "bt3");    // Creamos el objeto bt3. Sacar presion balona izq
NexDSButton bt4 = NexDSButton(1, 2, "bt4");    // Creamos el objeto bt4. Meter presion balona dcha
NexDSButton bt5 = NexDSButton(1, 4, "bt5");    // Creamos el objeto bt5. Sacar presion balona dcha
NexText t0 = NexText(0, 1, "t0");              // Creamos el objeto t0.  Texto estado compresor
NexText t2 = NexText(0, 6, "t2");              // Creamos el objeto t2.  Texto estado pantalla
NexGauge z0 =  NexGauge(1, 14, "z0");          // Creamos el objeto indicador de flecha presion
NexNumber n0 = NexNumber(1, 9, "n0");          // Creamos el objeto de la clase NexNumber llamado n0 visualizar enteros balona izq
NexNumber n1 = NexNumber(1, 10, "n1");         // Creamos el objeto de la clase NexNumber llamado n1 visualizar decimales balona izq
NexNumber n2 = NexNumber(1, 13, "n2");         // Creamos el objeto de la clase NexNumber llamado n2 visualizar enteros balona dcha
NexNumber n3 = NexNumber(1, 12, "n3");         // Creamos el objeto de la clase NexNumber llamado n3 visualizar decimales balona dcha


char buffer[100] = {0};                        // Creamos un array.
float presionActual;                           // Presion actual del compresor.

// Variables control datos serie.              // Lectura sensor presion.
char trama [30];
String readString = String(30);
int bytesLeidos;
String control;

const int sensorPresion = A0;
const int ledStatus = 13;


NexTouch *nex_listen_list[] = {                // Lista de escuchas provenientes de la nextion.
  &t0,                                         // Texto estado compresor
  &t2,                                         // Texto estado pantalla
  &n0,                                         // Boton number 0 lectura de presion enteros izq
  &n1,                                         // Boton number 1 lectura de presion decimales izq
  &n2,                                         // Boton number 2 lectura de presion enteros dcha
  &n3,                                         // Boton number 3 lectura de presion decimales dcha
  &bt0,                                        // Boton Encender y apagar compresor
  &bt1,                                        // Encender y apagar pantalla
  &bt2,                                        // Meter presion balona izq
  &bt3,                                        // Sacar presion balona izq
  &bt4,                                        // Meter presion balona dcha
  &bt5,                                        // Sacar presion balona dcha
  NULL
};

void n0PopCallback(void *ptr) {               // Funcion de llamada componente number.
  dbSerialPrintln("n0PopCallback");
  n0.setValue(50);
}
void setup(void) {
  // Parte botones pantalla 0
  nexInit();                                    // Iniciamos comunicacion con la pantalla Nextion.

  dbSerialPrintln("Fin del setup.");            // Imprimimos fin del setup por el puerto de depuracion.

  bt0.attachPop(bt0PopCallback, &bt0);          // Registrar la función de devolución de llamada del evento pop del componente del botón actual.
  bt1.attachPop(bt1PopCallback, &bt1);          // Registrar la función de devolución de llamada del evento pop del componente del botón actual.
  bt2.attachPop(bt2PopCallback, &bt2);          // Registrar la función de devolución de llamada del evento pop del componente del botón actual.
  bt3.attachPop(bt3PopCallback, &bt3);          // Registrar la función de devolución de llamada del evento pop del componente del botón actual.
  bt4.attachPop(bt4PopCallback, &bt4);          // Registrar la función de devolución de llamada del evento pop del componente del botón actual.
  bt5.attachPop(bt5PopCallback, &bt5);          // Registrar la función de devolución de llamada del evento pop del componente del botón actual.
  dbSerialPrintln("Setup Ok.");                 // Imprime en puerto depuracion.


  pinMode(8, OUTPUT);                           // Configuramos el pin 8 como salida (en mega esta un led conectado).
  digitalWrite(8, LOW);                         // Apagamos el led.
  pinMode(7, OUTPUT);                           // Configuramos el pin 7 como salida (en mega esta un led conectado).
  digitalWrite(7, LOW);                         // Apagamos el led.
  pinMode(6, OUTPUT);                           // Configuramos el pin 6 como salida (en mega esta un led conectado).
  digitalWrite(6, LOW);                         // Apagamos el led.
  pinMode(5, OUTPUT);                           // Configuramos el pin 5 como salida (en mega esta un led conectado).
  digitalWrite(5, LOW);                         // Apagamos el led.
  pinMode(4, OUTPUT);                           // Configuramos el pin 4 como salida (en mega esta un led conectado).
  digitalWrite(4, LOW);                         // Apagamos el led.
  pinMode(3, OUTPUT);                           // Configuramos el pin 3 como salida (en mega esta un led conectado).
  digitalWrite(3, LOW);                         // Apagamos el led.
  

}

void loop(void) {                                         // Lectura boton Gauge
  nexLoop(nex_listen_list);                               // Chequeamos la llegada de eventos desde la pantalla.
  encendido();
  int lectura = analogRead(pot);
  z0.setValue(map(lectura, 0, 1023, 0, 330));
  if (lectura < 45) {
    lectura += 330;
  }
  else {
    lectura -= 46;
  }
  if ((lectura > 212) && (lectura < 330))
    lectura = 212;
  z0.setValue(lectura);
}

void encendido () {                                // Botones pantalla 0

  uint32_t dual_state;
  bt0.getValue(&dual_state);


  if (dual_state)
  {
    t0.setText(" ON ");                            // Si -> Imprimimos en componente to BT0 on.
    digitalWrite(8, HIGH);

  }
  else
  {
    t0.setText(" OFF ");                           // No -> Imprimimos en componente to BT0 off.
    digitalWrite(8, LOW);

  }


  bt1.getValue(&dual_state);


  if (dual_state)
  {
    t2.setText(" ON ");                            // Si -> Imprimimos en componente to BT1 on.
    digitalWrite(7, HIGH);

  }
  else
  {
    t2.setText(" OFF ");                           // No -> Imprimimos en componente to BT1 off.
    digitalWrite(7, LOW);

  }

  bt2.getValue(&dual_state);

  if (dual_state)
  {
                                
    digitalWrite(6, HIGH);

  }
  else
  {
                               
    digitalWrite(7, LOW);

  }

    bt3.getValue(&dual_state);

  if (dual_state)
  {
                                
    digitalWrite(5, HIGH);

  }
  else
  {
                           
    digitalWrite(5, LOW);

  }

  bt4.getValue(&dual_state);

  if (dual_state)
  {
                                
    digitalWrite(4, HIGH);

  }
  else
  {
                           
    digitalWrite(4, LOW);

  }

  bt5.getValue(&dual_state);

  if (dual_state)
  {
                                
    digitalWrite(3, HIGH);

  }
  else
  {
                           
    digitalWrite(3, LOW);

  }
}



void bt0PopCallback(void *ptr)                                   // Función de devolución de llamada del componente de botón.

{
  dbSerialPrintln("boton bt0 pulsado");                       // Imprime puerto depuracion "boton b0 pulsado"
  digitalWrite(8, !digitalRead(8));                          // Cambia el estado del led de la patilla 8.
  delay(500);

}

void bt1PopCallback(void *ptr)                                   // Función de devolución de llamada del componente de botón.

{
  dbSerialPrintln("boton bt1 pulsado");                       // Imprime puerto depuracion "boton b1 pulsado"
  digitalWrite(7, !digitalRead(7));                          // Cambia el estado del led de la patilla 7.
  delay(500);

}

void bt2PopCallback(void *ptr)                                   // Función de devolución de llamada del componente de botón.

{
  dbSerialPrintln("boton bt2 pulsado");                       // Imprime puerto depuracion "boton b2 pulsado"
  digitalWrite(6, !digitalRead(6));                          // Cambia el estado del led de la patilla 6.
  delay(500);

}

void bt3PopCallback(void *ptr)                                   // Función de devolución de llamada del componente de botón.
{
  dbSerialPrintln("boton bt3 pulsado");                       // Imprime puerto depuracion "boton b3 pulsado"
  digitalWrite(5, !digitalRead(5));                          // Cambia el estado del led de la patilla 5.
  delay(500);

}

void bt4PopCallback(void *ptr)                                   // Función de devolución de llamada del componente de botón.
{
  dbSerialPrintln("boton bt4 pulsado");                       // Imprime puerto depuracion "boton b4 pulsado"
  digitalWrite(4, !digitalRead(4));                          // Cambia el estado del led de la patilla 4.
  delay(500);

}

void bt5PopCallback(void *ptr)                                   // Función de devolución de llamada del componente de botón.
{
  dbSerialPrintln("boton bt4 pulsado");                       // Imprime puerto depuracion "boton b4 pulsado"
  digitalWrite(3, !digitalRead(3));                          // Cambia el estado del led de la patilla 3.
  delay(500);

}
